<script setup>
    import { ref, watch } from 'vue';
    import ListeFactures from '@/components/listes/ListeFactures.vue';
    import axios from 'axios'
    import ROUTES_API from '@/assets/routesAPI.js'
    import BoutonRechercher from '@/components/boutons/BoutonRechercher.vue';

    const factures = ref([]);
    const critere = ref('toutes');
    const emetteur = ref();

    function rechercherFactures() {
        let route = ROUTES_API.FACTURES
        if (critere.value === 'emetteur') {
            route += '/emetteur/' + emetteur.value;
        }
        axios.get(route, {
            headers : {
                'Content-Type': 'application/json',
                'Accept': 'application/json'
            }
        })
        .then(response => {
            if (response.data) {
                factures.value = response.data;
            }    
        })
    }

    function supprimerFacture(id) {
        axios.delete(ROUTES_API.FACTURES + id, {
            headers : {
                'Content-Type': 'application/json',
                'Accept': 'application/json'
            }
        })
        .then(_ => {
            rechercherFactures(); 
        })
        .catch(e => {})
    }

    watch(critere, (val) => {
        if (val === 'toutes') {
            emetteur.value = null;
        }
    })

    rechercherFactures();
</script>

<template>
    <div>
        <div class="recherche">
            <select class="form-select" v-model="critere">
                <option value="toutes">Toutes</option>
                <option value="emetteur">Emetteur</option>
            </select>
            <input v-if="critere === 'emetteur'" type="text" v-model="emetteur"/>
            <BoutonRechercher @rechercher="rechercherFactures"/>
        </div>
        <ListeFactures :factures="factures" @supprimer="supprimerFacture"/>
    </div>
</template>

<style scoped>
.recherche {
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: center;
    margin-bottom: 10px;
  }

  .recherche select, .recherche input {
    flex: 1;
    margin-right: 10px;
  }
</style>
